package sun.reflect.generics.scope;

import java.lang.reflect.Constructor;
import java.lang.reflect.Method;

public class ClassScope extends AbstractScope<Class<?>> implements Scope
{
    private ClassScope(Class<?> clazz) {
        super(clazz);
    }
    
    @Override
    protected Scope computeEnclosingScope() {
        Class<Object> clazz = (Class)this.getRecvr();
        Method enclosingMethod = clazz.getEnclosingMethod();
        if (enclosingMethod != null) {
            return MethodScope.make(enclosingMethod);
        }
        Constructor<Object> enclosingConstructor = clazz.getEnclosingConstructor();
        if (enclosingConstructor != null) {
            return ConstructorScope.make(enclosingConstructor);
        }
        Class<Object> enclosingClass = clazz.getEnclosingClass();
        if (enclosingClass != null) {
            return make(enclosingClass);
        }
        return DummyScope.make();
    }
    
    public static ClassScope make(Class<?> clazz) {
        return new ClassScope(clazz);
    }
}
